<?php
/**
* @version      2.0.0 31.07.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class JshoppingControllerCart extends JController{
    
    function display(){
        $this->view();    
    }
    
    function add(){        

        $product_id = JRequest::getInt('product_id');
        $quantity = JRequest::getInt('quantity',1);
        $to = JRequest::getVar('to',"cart");
        if ($to!="cart" && $to!="wishlist") $to = "cart";        
        
        $jshop_attr_id = JRequest::getVar('jshop_attr_id');
        foreach($jshop_attr_id as $k=>$v) $jshop_attr_id[intval($k)] = intval($v);        
        
        $cart = &JModel::getInstance('cart', 'jshop');
        $cart->load($to);        
        $cart->add($product_id, $quantity, $jshop_attr_id);
        
        if ($to=="wishlist")
            $this->setRedirect( SEFLink('index.php?option=com_jshopping&controller=wishlist&task=view',0,1) );
        else
            $this->setRedirect( SEFLink('index.php?option=com_jshopping&controller=cart&task=view',0,1) );
    }
    
    function view(){
		
	    $jshopConfig = &JSFactory::getConfig();
		$db = &JFactory::getDBO();
		
		$cart = &JModel::getInstance('cart', 'jshop');        
		$cart->load();
        $cart->refreshCartWithNewCurrency();

		$cart->addLinkToProducts(1);
		appendPathWay(_JSHOP_CART);
		
		$view=&$this->getView("cart", 'html');
        $view->setLayout("cart");
        
		$view->assign('products', $cart->products);
		$view->assign('summ', $cart->getPriceProducts());
		$view->assign('image_product_path', $jshopConfig->image_product_live_path);
		$view->assign('image_path', $jshopConfig->live_path);
		$view->assign('no_image', 'noimage.gif');
		$view->assign('href_shop', SEFLink('index.php?option=com_jshopping&controller=category',1));
		$view->assign('href_checkout', SEFLink('index.php?option=com_jshopping&controller=checkout&task=step2',1));
		$view->assign('rabatt_summ', $cart->rabatt_summ);
		$view->assign('use_rabatt', $jshopConfig->use_rabatt_code);        
		$view->assign('tax_summ', $cart->getTax(0,1));        
        $view->assign('fullsumm', $cart->getSum(0,1));
               
		$view->display();
    }
    
    function delete(){
        $cart = &JModel::getInstance('cart', 'jshop');
        $cart->load();    
        $cart->delete(JRequest::getInt('number_id'));
        
        $this->setRedirect( SEFLink('index.php?option=com_jshopping&controller=cart&task=view',0,1) );
    }
    
    function refresh(){
        $cart = &JModel::getInstance('cart', 'jshop');
        $cart->load();
        $cart->refresh(JRequest::getVar('quantity'));    
        
        $this->setRedirect( SEFLink('index.php?option=com_jshopping&controller=cart&task=view',0,1) );
    }
    
    function discountsave(){

        $coupon = &JTable::getInstance('coupon', 'jshop');        
        $code = JRequest::getVar('rabatt');
        if($coupon->getEnableCode($code)){            
            $tax = &JTable::getInstance('tax', 'jshop');
            $tax->load($coupon->tax_id);
            $cart = &JModel::getInstance('cart', 'jshop');
            $cart->load();
            $cart->setRabatt($coupon->coupon_id, $coupon->coupon_type, $coupon->coupon_value, $tax->tax_value);
        } else {        
            JError::raiseWarning('',$coupon->error);
        }
        
        $this->setRedirect( SEFLink('index.php?option=com_jshopping&controller=cart&task=view',0,1) );
    }
    
}

?>		