<?php
/**
* @version      2.0.0 31.07.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class JshoppingControllerSearch extends JController{
    
    function display(){
    	$jshopConfig = &JSFactory::getConfig();
    	JHTML::_('behavior.calendar');
        
        $Itemid = JRequest::getInt('Itemid');
        
		$categories = buildTreeCategory(1);		
        $first = JHTML::_('select.option', 0, _JSHOP_SEARCH_ALL_CATEGORIES, 'category_id', 'name' );
		array_unshift($categories, $first);		
        $list_categories = JHTML::_('select.genericlist', $categories, 'category_id', 'class = "inputbox" size = "1"', 'category_id', 'name' );
		
        $first = JHTML::_('select.option', 0, _JSHOP_SEARCH_ALL_MANUFACTURERS, 'manufacturer_id', 'name');
        $_manufacturers = &JTable::getInstance('manufacturer', 'jshop');
		$manufacturers = jshopManufacturer::getAllManufacturers();
		array_unshift($manufacturers, $first);		
        $list_manufacturers = JHTML::_('select.genericlist', $manufacturers,'manufacturer_id','class = "inputbox" size = "1"','manufacturer_id','name' );
        
        $view=&$this->getView("search", 'html');
        $view->setLayout("form");
		$view->assign('list_categories', $list_categories);
		$view->assign('list_manufacturers', $list_manufacturers);
        $view->assign('config', $jshopConfig);
		$view->assign('Itemid', $Itemid);        
		$view->display();
    }
    
    function result(){
    global $mainframe;
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();
        $lang = &JSFactory::getLang();
        
        $category_id = JRequest::getInt('category_id');
        $manufacturer_id = JRequest::getInt('manufacturer_id');
        $date_to = JRequest::getVar('date_to', '');
        $date_from = JRequest::getVar('date_from', '');
        $price_to = floatval(JRequest::getVar('price_to', 0));
        $price_from = floatval(JRequest::getVar('price_from', 0));
        $include_subcat = JRequest::getInt('include_subcat');
        $search = JRequest::getVar('search','');
        $context = "jshoping.searclist.front.product";
        $orderby = $mainframe->getUserStateFromRequest( $context.'orderby', 'orderby', 0, 'int');
        $order = $mainframe->getUserStateFromRequest( $context.'order', 'order', 1, 'int');
        $limit = $mainframe->getUserStateFromRequest( $context.'limit', 'limit', $jshopConfig->count_products_to_page, 'int');
        if (!$limit) $limit = $jshopConfig->count_products_to_page;
        $limitstart = JRequest::getInt('limitstart',0);
        if ($order>3) $order=1;
        
        if($orderby) {
            $orderbyq = "DESC";
            $image_arr = 'arrow_down.gif';
        } else {
            $orderbyq = "ASC";
            $image_arr = 'arrow_up.gif';
        }

        $where = array();
        $from = array();
            
        if($date_to && checkMyDate($date_to)) {
            $where[] = " AND prod.product_date_added <= '".$db->getEscaped($date_to)."'";
        }
        if($date_from && checkMyDate($date_from)) {
            $where[] = " AND prod.product_date_added >= '".$db->getEscaped($date_from)."'";
        }
        
        if($price_to) {
            $where[] = " AND (prod.product_price * ".$jshopConfig->currency_value.") <= " . $price_to;
        } 
        if($price_from) {
            $where[] = " AND (prod.product_price * ".$jshopConfig->currency_value.") >= " . $price_from;
        }

        if($manufacturer_id) {
            $from[] = " INNER JOIN `#__jshopping_manufacturers` AS manuf ON prod.product_manufacturer_id = manuf.manufacturer_id ";
            $where[] = " AND prod.product_manufacturer_id = '".$manufacturer_id."'";
        }

        if($category_id) {
            if ($include_subcat) {
            	$_category = &JTable::getInstance('category', 'jshop');
                $all_categories = jshopCategory::getAllCategories();
                $cat_search[] = $category_id;
                searchChildCategories($category_id, $all_categories, $cat_search);
                $where_sub_cat = " AND (";
                foreach ($cat_search as $key => $value) {
                    $where_sub_cat .= "pr_cat.category_id = '" . $value . "' OR ";
                }
                $where_sub_cat = substr($where_sub_cat,0,strlen($where_sub_cat) - 3);
                $where_sub_cat .= ' )';
                $where[] = $where_sub_cat;
            } else {
                $where[] = " AND pr_cat.category_id = '" . $category_id . "'";
            }
        }
        
        $where_query = $from_query = '';
        foreach ($where as $wh) {
            $where_query .= $wh;
        }
        foreach ($from as $fr) {
            $from_query .= $fr;
        }                
                
        $search = addcslashes($db->getEscaped($search), "_%");
                
        $query = "SELECT DISTINCT prod.*, prod.`".$lang->get('name')."` as name, prod.`".$lang->get('short_description')."` as short_description, (" . $jshopConfig->currency_value . " * prod.product_price) AS product_price, pr_cat.category_id
                  FROM `#__jshopping_products` AS prod
                  LEFT JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                  $from_query
                  WHERE (LOWER(prod.`".$lang->get('name')."`) LIKE '%" . $search . "%' OR LOWER(prod.`".$lang->get('short_description')."`) LIKE '%" . $search . "%' OR LOWER(prod.`".$lang->get('description')."`) LIKE '%" . $search . "%') AND prod.product_publish = '1'
                  $where_query                  
                  GROUP BY prod.product_id";
        $db->setQuery($query);
        $db->query();
        $total = intval($db->getNumRows());
        if(!$total) {
            echo _JSHOP_NO_SEARCH_RESULTS;
            return 0;
        }
        
        $orderbyf = $jshopConfig->sorting_products_field_s_select[$order];
        if ($orderbyf){
            $query = $query." order by ".$orderbyf." ".$orderbyq;
        }
        $db->setQuery($query, $limitstart, $limit);
        $rows = $db->loadObjectList();
        
        $userShop = &JSFactory::getUserShop();
        foreach ($rows as $key=>$value){
            $rows[$key]->product_price = getPriceDiscount($rows[$key]->product_price, $userShop->percent_discount);
        }
        addLinkToProducts($rows,0,1);
        
        jimport('joomla.html.pagination');
        $pagination = new JPagination($total, $limitstart, $limit);            
        $pagenav = $pagination->getPagesLinks();
        
        foreach ($jshopConfig->sorting_products_name_s_select as $key => $value) {
            $sorts[] = JHTML::_('select.option', $key, $value, 'sort_id', 'sort_value' );
        }

        insertValueInArray($jshopConfig->count_products_to_page, $jshopConfig->count_product_select); //insert category count
        foreach ($jshopConfig->count_product_select as $key => $value) {            
            $product_count[] = JHTML::_('select.option',$key, $value, 'count_id', 'count_value' );
        }        
        $sorting_sel = JHTML::_('select.genericlist', $sorts, 'order', 'id = "sort_products" class = "inputbox" size = "1" onchange = "changeSortCountProducts(0)"','sort_id', 'sort_value', $order );
        $product_count_sel = JHTML::_('select.genericlist', $product_count, 'limit', 'id = "limit_products" class = "inputbox" size = "1" onchange = "changeSortCountProducts(0)"','count_id', 'count_value', $limit );
        
        $action = $_SERVER['REQUEST_URI'];
                        
        $view=&$this->getView("search", 'html');
        $view->setLayout("result");
        
        $view->assign('product_count', $product_count_sel);
        $view->assign('sorting', $sorting_sel);
        $view->assign('image_arr', $image_arr);
        $view->assign('action', $action);
        $view->assign('orderby', $orderby);
                
        $view->assign('navigation_products', $pagenav);        
        $view->assign('count_product_to_row', $jshopConfig->count_products_to_row);
        $view->assign('lists_prod', $rows);
        $view->assign('Itemid', $Itemid);
        $view->assign('noimage','noimage.gif');
        $view->assign('image_path', $jshopConfig->live_path.'images');
        $view->assign('image_product_path', $jshopConfig->image_product_live_path);
        $view->display();
    }
    
}

?>