<?php
/**
* @version      2.0.0 31.07.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

class jshopProduct extends JTableAvto {    

    function __construct( &$_db ){
        parent::__construct( '#__jshopping_products', 'product_id', $_db );
    }
    
    function getAttributes() {
        $query = "SELECT * FROM `#__jshopping_products_attr` WHERE product_id = '".$this->product_id."' ORDER BY product_attr_id";
        $this->_db->setQuery($query);
        $rows = $this->_db->loadObjectList();
        return $rows;
    }
    
    function getAttribValue($attr_id, $other_attr=array(), $onlyExistProduct=0){
        $jshopConfig = &JSFactory::getConfig();
        $lang = &JSFactory::getLang();
        $where="";
        foreach($other_attr as $k=>$v){
            $where.=" and PA.attr_$k='$v'";
        }
        if ($onlyExistProduct) $where.=" and PA.count>0 ";
        
        $field = "attr_".$attr_id;
        $query = "SELECT distinct PA.$field as val_id, V.`".$lang->get("name")."` as value_name, V.image
                  FROM `#__jshopping_products_attr` as PA INNER JOIN #__jshopping_attr_values as V ON PA.$field=V.value_id
                  WHERE PA.product_id = '".$this->product_id."' ".$where."
                  ORDER BY V.value_ordering";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }

    function getCategories() {
        $db =& JFactory::getDBO(); 
        $query = "SELECT * FROM `#__jshopping_products_to_categories` AS pr_cat
                   WHERE pr_cat.product_id = '" . $this->_db->getEscaped($this->product_id) . "'";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }

    function getName() {
        $lang = &JSFactory::getLang();
        $name = $lang->get('name');
        return $this->$name;
    }

    function updateProductInStock($listProducts) {
        $db =& JFactory::getDBO(); 

        foreach ($listProducts as $prod) {
            if ( is_array($prod['attr']) && count($prod['attr']) ){                
                $where="";
                foreach($prod['attr'] as $k=>$v){
                    $where.=" and `attr_$k`='".intval($v)."'";        
                }
                $query = "update `#__jshopping_products_attr` set `count`=`count`-".intval($prod['quantity'])." where product_id='".intval($prod['product_id'])."' ".$where;
                $db->setQuery($query);
                $db->query();
                
                $query="select sum(count) as qty from `#__jshopping_products_attr` where product_id='".intval($prod['product_id'])."' and `count`>0 ";
                $db->setQuery($query);
                $qty = $db->loadResult();
                
                $query = "UPDATE `#__jshopping_products` SET product_quantity = '".intval($qty)."' WHERE product_id = '".intval($prod['product_id'])."'";
                $db->setQuery($query);
                $db->query();
                
            }else{
                $query = "UPDATE `#__jshopping_products` SET product_quantity = product_quantity - ".intval($prod['quantity'])." WHERE product_id = '".intval($prod['product_id'])."'";
                $db->setQuery($query);
                $db->query();
            }
        }
        
    }

    function getPriceWithAttributes($attribs){
        $jshopConfig = &JSFactory::getConfig();        
        $where="";
        foreach($attribs as $k=>$v){
            $where.=" and PA.attr_".$k." = '".$this->_db->getEscaped($v)."' ";
        }          
        $query = "select (PA.price * ".$jshopConfig->currency_value.") AS price from `#__jshopping_products_attr` as PA 
                  where PA.product_id = '".$this->_db->getEscaped($this->product_id)."' ".$where; 
        $this->_db->setQuery($query);
        $row = $this->_db->loadObject();
        if (!isset($row->price)){ 
            return 0;
        }else{
            $userShop = &JSFactory::getUserShop();
            $row->price = getPriceDiscount($row->price, $userShop->percent_discount);
            return $row->price;        
        }
    }
    
    function getEanWithAttributes($attribs){
        $jshopConfig = &JSFactory::getConfig();        
        $where="";
        foreach($attribs as $k=>$v){
            $where.=" and PA.attr_".$k." = '".$this->_db->getEscaped($v)."' ";
        }          
        $query = "select ean from `#__jshopping_products_attr` as PA  where PA.product_id = '".$this->_db->getEscaped($this->product_id)."' ".$where; 
        $this->_db->setQuery($query);
        $row = $this->_db->loadObject();        
        return $row->ean;   
    }

    function getImages() {
        $jshopConfig = &JSFactory::getConfig();
        $query = "SELECT I.*, IF(P.product_name_image=I.image_name,0,1) as sort FROM `#__jshopping_products_images` as I left join `#__jshopping_products` as P on P.product_id=I.product_id
                 WHERE I.product_id = '" . $this->_db->getEscaped($this->product_id) . "' ORDER BY sort,I.image_id";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }

    function getVideos() {
        $jshopConfig = &JSFactory::getConfig();
        $query = "SELECT  videos.video_name, videos.video_id, videos.video_preview FROM `#__jshopping_products_videos` AS videos
                WHERE videos.product_id = '" . $this->_db->getEscaped($this->product_id) . "'";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }

    function getRelatedProducts() {
        $jshopConfig = &JSFactory::getConfig();
        $lang = &JSFactory::getLang();
        
        $query = "SELECT relation.product_related_id AS product_id, (prod.product_price*" . $jshopConfig->currency_value . ") AS product_price, pr_cat.category_id, prod.product_thumb_image, prod.product_is_add_price, prod.`".$lang->get('name')."` as name
                FROM `#__jshopping_products_relations` AS relation
                INNER JOIN `#__jshopping_products` AS prod ON relation.product_related_id = prod.product_id
                LEFT JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = relation.product_related_id
                WHERE relation.product_id = '" . $this->_db->getEscaped($this->product_id) . "' AND prod.product_publish = '1' group by prod.product_id ";
        $this->_db->setQuery($query);        
        $products = $this->_db->loadObjectList();
        
        if ($this->_db->getErrorNum()) {    
            JError::raiseError( 500, "Error DB" );    
            return false;
        }
        
        $userShop = &JSFactory::getUserShop();
        $this->product_related = $products;
        foreach ($this->product_related as $key => $value) {
            $this->product_related[$key]->product_link = SEFLink('index.php?option=com_jshopping&controller=product&task=view&category_id='.$value->category_id.'&product_id='.$value->product_id);
            $this->product_related[$key]->product_price = getPriceDiscount($this->product_related[$key]->product_price, $userShop->percent_discount);            
        }
                        
        return $this->product_related;
    }

    function getDownloadFile() {
        $query = "SELECT prod.product_download_file AS file FROM `#__jshopping_products` AS prod
                  WHERE prod.product_id = '" . $this->_db->getEscaped($this->product_id) . "'";
        $this->_db->setQuery($query);
        return $this->_db->loadResult();
    }

    function getCategory() {
        $query = "SELECT cat.category_id FROM `#__jshopping_products_to_categories` AS cat
                WHERE cat.product_id = '" . $this->_db->getEscaped($this->product_id) . "'
                LIMIT 0,1";
        $this->_db->setQuery($query);
        $this->category_id = $this->_db->loadResult();
    }
    
    function getExtendsData() {
        $this->getRelatedProducts();
        $this->getDescription();
        $this->getPricePreview();
        $this->getTax();
    }

    function getDescription() {
        $lang = &JSFactory::getLang();
        $name = $lang->get('name');
        $short_description = $lang->get('short_description');
        $description = $lang->get('description');
        $meta_title = $lang->get('meta_title');
        $meta_keyword = $lang->get('meta_keyword');
        $meta_description = $lang->get('meta_description');
        
        $this->name = $this->$name;
        $this->short_description = $this->$short_description;
        $this->description = $this->$description;
        $this->meta_title = $this->$meta_title;
        $this->meta_keyword = $this->$meta_keyword;
        $this->meta_description = $this->$meta_description;
    }
    
    function getPricePreview() {
        $jshopConfig = &JSFactory::getConfig();
        $this->product_price = $this->product_price * $jshopConfig->currency_value;
        
        $userShop = &JSFactory::getUserShop();
        $this->product_price = getPriceDiscount($this->product_price, $userShop->percent_discount);    
        
        $this->getAddPrices();
        $this->product_add_prices = array_reverse($this->product_add_prices);    
    }
    
    function getPrice($quantity) {
        $jshopConfig = &JSFactory::getConfig();
        $this->product_price = $this->product_price * $jshopConfig->currency_value;

        $userShop = &JSFactory::getUserShop();
        $this->product_price = getPriceDiscount($this->product_price, $userShop->percent_discount);    
        
        $this->getAddPrices();
        if ($quantity && $this->product_is_add_price){
            foreach ($this->product_add_prices as $key=>$value){
                if ($quantity >= $value->product_quantity_start){
                    $this->product_price = $value->product_price;
                    break;    
                } 
            }
        }
        return $this->product_price;
    }
    
    function getAddPrices(){
        $jshopConfig = &JSFactory::getConfig();
        $productprice = &JTable::getInstance('productprice', 'jshop');                
        $this->product_add_prices = $productprice->getAddPrices($this->product_id);
        
        $userShop = &JSFactory::getUserShop();
        foreach ($this->product_add_prices as $key=>$value){
            $value->product_price = 
            $this->product_add_prices[$key]->product_price = $this->product_add_prices[$key]->product_price * $jshopConfig->currency_value;
            $this->product_add_prices[$key]->product_price = getPriceDiscount($this->product_add_prices[$key]->product_price, $userShop->percent_discount);
        }
    }
    
    function getTax() {
        $jshopConfig = &JSFactory::getConfig();
        $query = "SELECT tax.tax_value FROM `#__jshopping_products` AS prod
                  LEFT JOIN `#__jshopping_taxes` AS tax ON prod.product_tax_id = tax.tax_id
                  WHERE prod.product_id = '" . $this->_db->getEscaped($this->product_id) . "'
                  LIMIT 0,1";
        $this->_db->setQuery($query);
        $row = $this->_db->loadObject();
        $this->product_tax = $row->tax_value;
    }
    
    function getLastProducts($count, $array_categories = null, $rand = 0) {
        $jshopConfig = &JSFactory::getConfig();             

        $db =& JFactory::getDBO();
        $lang = &JSFactory::getLang();
        $where_add = '';
        if(count($array_categories)) {
            $where_add = " AND (";
            foreach ($array_categories as $key => $value) {
                $where_add .= " pr_cat.category_id = '" . $value . "' OR ";
            }
            $where_add = substr($where_add,0,strlen($where_add) - 4);
            $where_add .= ")";
        }
 
        $order_add = ($rand)?("RAND()"):("prod.product_date_added DESC");
        $query = "SELECT 
            prod.`".$lang->get('name')."` as name, 
            prod.`".$lang->get('short_description')."` as short_description, 
            prod.product_id, 
            prod.product_ean, 
            prod.product_url, 
            prod.product_thumb_image, 
            prod.product_full_image, 
            pr_cat.category_id, 
            (prod.product_price*" . $jshopConfig->currency_value . ") AS product_price, 
            product_is_add_price
                  FROM `#__jshopping_products` AS prod
                  INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                  WHERE prod.product_publish = '1'" . $where_add . "
                  GROUP BY prod.product_id
                  ORDER BY " . $order_add . "
                  LIMIT " . $count;
        $db->setQuery($query);
        $products = $db->loadObjectList();
        $userShop = &JSFactory::getUserShop();
        foreach ($products as $key=>$value){
            $products[$key]->product_price = getPriceDiscount($products[$key]->product_price, $userShop->percent_discount);    
        }
        return $products;
    }
    
    //not test
    function getBestProducts($product_ids){
        $jshopConfig = &JSFactory::getConfig();
        $db =& JFactory::getDBO(); 
        if (strlen($product_ids)){
            $where_add = " AND prod.product_id IN (" . $product_ids . ")";
            $query = "SELECT prod.`".$lang->get('name')."` as name, prod.`".$lang->get('short_description')."` as short_description, prod.product_id, prod.product_ean, prod.product_url, prod.product_thumb_image, pr_cat.category_id, (prod.product_price*" . $jshopConfig->currency_value . ") AS product_price
                      FROM `#__jshopping_products` AS prod
                      INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                      WHERE prod.product_publish = '1'" . $where_add . "
                      GROUP BY prod.product_id
                      ORDER BY prod.product_id";
            $db->setQuery($query);
            return $db->loadObjectList();
        }
    }
    
    
    function getBestSellers($count, $array_categories = null){
        $jshopConfig = &JSFactory::getConfig();             

        $db =& JFactory::getDBO();
        $lang = &JSFactory::getLang();

        $where_add = '';
        if(count($array_categories)) {
            $where_add = " AND (";
            foreach ($array_categories as $key => $value) {
                $where_add .= " pr_cat.category_id = '" . $value . "' OR ";
            }
            $where_add = substr($where_add,0,strlen($where_add) - 4);
            $where_add .= ")";
        }
 
        $query = "SELECT 
            SUM(OI.product_quantity) as max_num,
            prod.`".$lang->get('name')."` as name, 
            prod.`".$lang->get('short_description')."` as short_description, 
            prod.product_id, 
            prod.product_ean, 
            prod.product_url, 
            prod.product_thumb_image, 
            prod.product_full_image, 
            pr_cat.category_id, 
            (prod.product_price*" . $jshopConfig->currency_value . ") AS product_price, 
            product_is_add_price
            FROM #__jshopping_order_item AS OI 
                  INNER JOIN `#__jshopping_products` AS prod   ON prod.product_id=OI.product_id
                  INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                  WHERE prod.product_publish = '1'" . $where_add . "
                  GROUP BY prod.product_id
                  ORDER BY max_num desc
                  LIMIT " . $count;
        $db->setQuery($query);
        $products = $db->loadObjectList();
        $userShop = &JSFactory::getUserShop();
        foreach ($products as $key=>$value){
            $products[$key]->product_price = getPriceDiscount($products[$key]->product_price, $userShop->percent_discount);    
        }
        return $products;
    }
    
    function getReviews($limitstart=0, $limit=20) {
        $query = "SELECT * FROM `#__jshopping_products_reviews` WHERE product_id = '" . $this->_db->getEscaped($this->product_id) . "' order by review_id desc";
        $this->_db->setQuery($query, $limitstart, $limit);
        return $this->_db->loadObjectList();
    }
    
    function getReviewsCount(){
        $query = "SELECT count(review_id) FROM `#__jshopping_products_reviews` WHERE product_id = '" . $this->_db->getEscaped($this->product_id) . "'";
        $this->_db->setQuery($query);
        return $this->_db->loadResult();
    }

    function getAverageRating() {
        $query = "SELECT ROUND(AVG(review.mark),2) FROM `#__jshopping_products_reviews` AS review
                  WHERE review.product_id = '" . $this->_db->getEscaped($this->product_id). "' and review.mark>0";
        $this->_db->setQuery($query);
        return $this->_db->loadResult();
    }

}
?>